#include <iostream>
#include <string>
#include <algorithm>
#include <cassert>

using namespace std;

struct pupil
{
	string fam;
	string name;
	string clas;
	string date;
};

bool comp(pupil& arg1, pupil& arg2) 
{ 
	if (arg1.clas != arg2.clas)
		return arg1.clas < arg2.clas;
	assert(arg1.fam != arg2.fam);
	return arg1.fam < arg2.fam;
}

void checkname(string str)
{
	int len = str.length();
	assert(len >= 1 && len <= 20);

	assert(str[0] >= 'A' && str[0] <= 'Z');
	for (int i = 1; i < len; i++)
	{
		assert(str[i] >= 'a' && str[i] <= 'z');
	}
}

void checkclass(string str)
{
	int len = str.length();
	assert(len >= 2 && len <= 3);
	if (len == 2)
	{
		assert(str[0] >= '1' && str[0] <= '9');
		assert(str[1] >= 'A' && str[1] <= 'Z');
	}
	else
	{
		assert(str[0] == '1');
		assert(str[1] >= '0' && str[1] <= '1');
	}
	assert(str[len - 1] >= 'A' && str[len - 1] <= 'Z');
}

int main()
{
	freopen("pupil.in", "rt", stdin);
	//freopen("pupil.out", "wt", stdout);
	
	pupil a[1024];

	int testn;
	cin >> testn;
	for (int testi = 0; testi < testn; testi++)
	{
		int n;
		cin >> n;
		assert(n >= 1 && n <= 100);
		cin.get();

		for (int i = 0; i < n; i++)
		{
			getline(cin, a[i].fam);
			checkname(a[i].fam);

			getline(cin, a[i].name);
			checkname(a[i].name);


			getline(cin, a[i].clas);
			checkclass(a[i].clas);

			if (a[i].clas.length() == 2)
				a[i].clas = "0" + a[i].clas;

			getline(cin, a[i].date);
			assert(a[i].date.length() == 8);
		}

		sort(a, a + n, comp);
		/*
		for (int i = 0; i < n - 1; i++)
		{
			for (int j = i + 1; j < n; j++)
			{
				if (comp(a[j], a[i]))
					swap(a[i], a[j]);
			}
		}
		*/


		cout << "Case " << testi + 1 << ":" << endl;
		for (int i = 0; i < n; i++)
		{
			if (a[i].clas[0] == '0')
				a[i].clas.erase(a[i].clas.begin(), a[i].clas.begin() + 1);
			cout << a[i].clas << ' ' << a[i].fam << ' ' << a[i].name << ' ' << a[i].date << endl;
		}		
	}
	
	return 0;
}