#include <iostream>
#include <cmath>
#include <cassert>

using namespace std;

double f(double x, double c)
{
	return x*x - sqrt(x) + c;
}

double rbs(double l, double r, double c)
{
	double m = (l + r)/2.0;
	while (m != r && m != l)
	{
		if (f(m, c) > 0)
			r = m;
		else
			l = m;
		m = (l + r)/2.0;
	}
	return m;
}

double lbs(double l, double r, double c)
{
	double m = (l + r)/2.0;
	while (m != r && m != l)
	{
		if (f(m, c) > 0)
			l = m;
		else
			r = m;
		m = (l + r)/2.0;
	}
	return m;
}

int main()
{
	freopen("function.in", "rt", stdin);
	//freopen("function.out", "wt", stdout);
	
	int testn;
	scanf("%d", &testn);

	double x0 = pow(0.25, 2.0/3.0);
	double f0 = f(x0, 0);

	for (int testi = 0; testi < testn; testi++)
	{
		double c;
		scanf("%lf", &c);
		assert(abs(c) <= 10000000000.0);
		c *= -1;

		if (c > -f0)
		{
			printf("No solution\n");
		}
		else if (c >= 0 && c <= -f0)
		{
			double xl = lbs(0.0, x0, c);
			double xr = rbs(x0, 1.0, c);
			printf("%.6lf %.6lf\n", xl, xr);
		}
		else 
		{
			double l = 1.0;
			double r = 1.0;
			while (f(r, c) < 0)
				r *= 2;
			double x = rbs(l, r, c);
			printf("%.6lf\n", x);
		}
	}
	
	return 0;
}