#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const double EPS = 0.000000000001;
double C;

double f(double x)
{
	if (x < -EPS)
		x = 0;
	return x*x - sqrt(x);
}

double bs(double low, double hi, bool increasing)
{
	double mid;
	int i = 0;

	while (i++ < 5000)
	{
		mid = low + (hi - low) / 2.0;	
		double val = f(mid);

		if (increasing)
		{
			if (val < C)
				low = mid;
			else
				hi = mid;
		}
		else
		{
			if (val < C)
				hi = mid;
			else
				low = mid;
		}
	}

	return mid;
}

void main()
{
	freopen("function.in", "r", stdin);
	//freopen("function.out.gs", "w", stdout);

	int tc;
	cout.setf(ios_base::fixed);
	cout.precision(6);
	cin >>tc;
	for (int cc = 0;cc < tc;cc++)
	{		
		cin >>C;
		double l = pow(0.25, 2.0 / 3.0);

		if (f(l) > C)
			cout <<"No solution";
		else if (f(1) < C)
		{
			double s = bs(1, 1e10, true);
			cout <<s;
		}
		else
		{
			double a, b;
			a = bs(0, l, false);
			b = bs(l, 1, true);
			cout <<a <<" " <<b;
		}
		cout <<endl;
	}
}
