#include <iostream>
#include <cassert>
#include <string>

using namespace std;

struct point
{
	int row, col, steps;
};

const int MAX_N = 1000;
const int MAX_M = 1000;

bool a[MAX_N][MAX_M] = {0};
point q[MAX_N * MAX_M] = {0};

int main()
{
	freopen("game.in", "rt", stdin);
	//freopen("game.out", "wt", stdout);

	int testn;
	cin >> testn;

	const int steps = 6;
	int drowodd[steps] = {-1, -1, 0, 1, 1,  0};
	int dcolodd[steps] = { 0,  1, 1, 1, 0, -1};

	int droweven[steps] = {-1, 0, 1,  1,  0, -1};
	int dcoleven[steps] = { 0, 1, 0, -1, -1, -1};

	//http://sviridenkov.livejournal.com/160452.html
	for (int testi = 0; testi < testn; testi++)
	{
		int rows, cols;
		cin >> rows >> cols;
		assert(rows >= 1 && rows <= MAX_N);
		assert(cols >= 1 && cols <= MAX_M);

		int srow, scol;
		cin >> srow >> scol;
		assert(srow >= 1 && srow <= rows);
		assert(scol >= 1 && scol <= cols);
		srow--;
		scol--;
		
		cin.get();
		for (int i = 0; i < rows; i++)
		{
			char buf[MAX_M + 10] = {0};
			gets(buf);
			
			assert(strlen(buf) == cols);

			for (int j = 0; j < cols; j++)
			{
				assert(buf[j] == '1' || buf[j] == '0');
				a[i][j] = buf[j] == '1' ? true : false;
			}
		}

		int l = 0;
		int r = 0;
		q[r].row = srow;
		q[r].col = scol;
		q[r].steps = 0;
		assert(a[srow][scol] == true);
		a[srow][scol] = false;
		r++;

		int result = 0;
		while (l < r && result == 0)
		{
			point cur = q[l];
			l++;

			for (int i = 0; i < steps; i++)
			{
				int row = cur.row + (cur.row % 2 ? drowodd[i] : droweven[i]);
				int col = cur.col + (cur.row % 2 ? dcolodd[i] : dcoleven[i]);

				if (row < 0 || col < 0 || row >= rows || col >= cols)
				{
					result = cur.steps + 1;
					break;
				}

				if (a[row][col])
				{
					q[r].row = row;
					q[r].col = col;
					q[r].steps = cur.steps + 1;
					r++;
					a[row][col] = false;
				}
			}
		}

		if (result > 0)
			cout << result << endl;
		else
			cout << "No solution" << endl;
	}

	return 0;
}